<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLateJoinerPenalty ArrayType
 * @subpackage Arrays
 */
class ArrayOfLateJoinerPenalty extends AbstractStructArrayBase
{
    /**
     * The LateJoinerPenalty
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\LateJoinerPenalty[]
     */
    public $LateJoinerPenalty;
    /**
     * Constructor method for ArrayOfLateJoinerPenalty
     * @uses ArrayOfLateJoinerPenalty::setLateJoinerPenalty()
     * @param \StructType\LateJoinerPenalty[] $lateJoinerPenalty
     */
    public function __construct(array $lateJoinerPenalty = array())
    {
        $this
            ->setLateJoinerPenalty($lateJoinerPenalty);
    }
    /**
     * Get LateJoinerPenalty value
     * @return \StructType\LateJoinerPenalty[]|null
     */
    public function getLateJoinerPenalty()
    {
        return $this->LateJoinerPenalty;
    }
    /**
     * This method is responsible for validating the values passed to the setLateJoinerPenalty method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLateJoinerPenalty method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLateJoinerPenaltyForArrayConstraintsFromSetLateJoinerPenalty(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLateJoinerPenaltyLateJoinerPenaltyItem) {
            // validation for constraint: itemType
            if (!$arrayOfLateJoinerPenaltyLateJoinerPenaltyItem instanceof \StructType\LateJoinerPenalty) {
                $invalidValues[] = is_object($arrayOfLateJoinerPenaltyLateJoinerPenaltyItem) ? get_class($arrayOfLateJoinerPenaltyLateJoinerPenaltyItem) : sprintf('%s(%s)', gettype($arrayOfLateJoinerPenaltyLateJoinerPenaltyItem), var_export($arrayOfLateJoinerPenaltyLateJoinerPenaltyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LateJoinerPenalty property can only contain items of type \StructType\LateJoinerPenalty, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LateJoinerPenalty value
     * @throws \InvalidArgumentException
     * @param \StructType\LateJoinerPenalty[] $lateJoinerPenalty
     * @return \ArrayType\ArrayOfLateJoinerPenalty
     */
    public function setLateJoinerPenalty(array $lateJoinerPenalty = array())
    {
        // validation for constraint: array
        if ('' !== ($lateJoinerPenaltyArrayErrorMessage = self::validateLateJoinerPenaltyForArrayConstraintsFromSetLateJoinerPenalty($lateJoinerPenalty))) {
            throw new \InvalidArgumentException($lateJoinerPenaltyArrayErrorMessage, __LINE__);
        }
        $this->LateJoinerPenalty = $lateJoinerPenalty;
        return $this;
    }
    /**
     * Add item to LateJoinerPenalty value
     * @throws \InvalidArgumentException
     * @param \StructType\LateJoinerPenalty $item
     * @return \ArrayType\ArrayOfLateJoinerPenalty
     */
    public function addToLateJoinerPenalty(\StructType\LateJoinerPenalty $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LateJoinerPenalty) {
            throw new \InvalidArgumentException(sprintf('The LateJoinerPenalty property can only contain items of type \StructType\LateJoinerPenalty, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LateJoinerPenalty[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LateJoinerPenalty|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LateJoinerPenalty|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LateJoinerPenalty|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LateJoinerPenalty|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LateJoinerPenalty|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LateJoinerPenalty
     */
    public function getAttributeName()
    {
        return 'LateJoinerPenalty';
    }
}
