<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPreviousMedicalScheme ArrayType
 * @subpackage Arrays
 */
class ArrayOfPreviousMedicalScheme extends AbstractStructArrayBase
{
    /**
     * The PreviousMedicalScheme
     * Meta information extracted from the WSDL
     * - maxOccurs: 20
     * - minOccurs: 0
     * @var \StructType\PreviousMedicalScheme[]
     */
    public $PreviousMedicalScheme;
    /**
     * Constructor method for ArrayOfPreviousMedicalScheme
     * @uses ArrayOfPreviousMedicalScheme::setPreviousMedicalScheme()
     * @param \StructType\PreviousMedicalScheme[] $previousMedicalScheme
     */
    public function __construct(array $previousMedicalScheme = array())
    {
        $this
            ->setPreviousMedicalScheme($previousMedicalScheme);
    }
    /**
     * Get PreviousMedicalScheme value
     * @return \StructType\PreviousMedicalScheme[]|null
     */
    public function getPreviousMedicalScheme()
    {
        return $this->PreviousMedicalScheme;
    }
    /**
     * This method is responsible for validating the values passed to the setPreviousMedicalScheme method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPreviousMedicalScheme method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePreviousMedicalSchemeForArrayConstraintsFromSetPreviousMedicalScheme(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem instanceof \StructType\PreviousMedicalScheme) {
                $invalidValues[] = is_object($arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem) ? get_class($arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem) : sprintf('%s(%s)', gettype($arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem), var_export($arrayOfPreviousMedicalSchemePreviousMedicalSchemeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PreviousMedicalScheme property can only contain items of type \StructType\PreviousMedicalScheme, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PreviousMedicalScheme value
     * @throws \InvalidArgumentException
     * @param \StructType\PreviousMedicalScheme[] $previousMedicalScheme
     * @return \ArrayType\ArrayOfPreviousMedicalScheme
     */
    public function setPreviousMedicalScheme(array $previousMedicalScheme = array())
    {
        // validation for constraint: array
        if ('' !== ($previousMedicalSchemeArrayErrorMessage = self::validatePreviousMedicalSchemeForArrayConstraintsFromSetPreviousMedicalScheme($previousMedicalScheme))) {
            throw new \InvalidArgumentException($previousMedicalSchemeArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(20)
        if (is_array($previousMedicalScheme) && count($previousMedicalScheme) > 20) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 20', count($previousMedicalScheme)), __LINE__);
        }
        $this->PreviousMedicalScheme = $previousMedicalScheme;
        return $this;
    }
    /**
     * Add item to PreviousMedicalScheme value
     * @throws \InvalidArgumentException
     * @param \StructType\PreviousMedicalScheme $item
     * @return \ArrayType\ArrayOfPreviousMedicalScheme
     */
    public function addToPreviousMedicalScheme(\StructType\PreviousMedicalScheme $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PreviousMedicalScheme) {
            throw new \InvalidArgumentException(sprintf('The PreviousMedicalScheme property can only contain items of type \StructType\PreviousMedicalScheme, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(20)
        if (is_array($this->PreviousMedicalScheme) && count($this->PreviousMedicalScheme) >= 20) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 20', count($this->PreviousMedicalScheme)), __LINE__);
        }
        $this->PreviousMedicalScheme[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PreviousMedicalScheme|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PreviousMedicalScheme|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PreviousMedicalScheme|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PreviousMedicalScheme|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PreviousMedicalScheme|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PreviousMedicalScheme
     */
    public function getAttributeName()
    {
        return 'PreviousMedicalScheme';
    }
}
